/*
 * Activation.java
 *
 * Created on 2006~0106 P, W12:44
 */

package ivan.pums.assess.actions;

import ivan.pums.assess.process.RegisterService;
import ivan.pums.assess.process.UserManagementService;
import jim.pums.actions.PumsBaseAction;
import jim.util.struts.StrutsUtils;
import jim.util.struts.JimActionErrors;
import jim.common.JimFatalException;
import java.io.IOException;
import javax.servlet.ServletException;
import org.apache.struts.action.ActionForward;
import ivan.pums.assess.process.Logger;
import jim.common.Trace;

/**
 * Receive Activation and processing
 * @author IVAN
 */

public class Activation extends PumsBaseAction {
    
    public Activation() {
    }
    
    /**
     * Action execution
     * @param su Jim App Struts Resources
     * @throws java.io.IOException IO Exception
     * @throws javax.servlet.ServletException Servlet Exception
     * @throws jim.common.JimFatalException Jim Fatal Exception
     * @return ActionForward
     */
    public ActionForward doPumsExecute(StrutsUtils su) throws IOException, ServletException, JimFatalException {
        JimActionErrors errors = su.getErrors();
        if (!errors.isEmpty()) {
            return su.getMapping().findForward("failure");
        }
        
        try {
            String code = su.getRequest().getParameter("CODE");
            Logger logger = new Logger(su.getSqlUtils());
            UserManagementService us = new UserManagementService(su.getConn());
            
            if(code.equals("")){
                return su.getMapping().findForward("entry");
            }
            
            RegisterService ps = new RegisterService(su.getConn());
            
            int person_id = ps.getPersonIdByCode(code); //retrieve person id from code
            
            if (person_id > 0) {
                ps.setActive(person_id); //set person to active
                ps.delActiveCode(person_id); //delete activation code in database
                logger.log(person_id,person_id,"Activate by CODE","inactive", "true", "false");
            }else{
                return su.getMapping().findForward("failure");
            }
            
        } catch (Exception e) {
            errors.addGlobal("pums.errors.dberror", "Could not get activation code: " + e.getMessage());
        }
        
        return su.successOrFailure();
    }
    
}
