/*
 * ForgotPassword.java
 *
 * Created on 2006~0107 P, W12:10
 */

package ivan.pums.assess.actions;

import jim.pums.actions.PumsBaseAction;
import jim.util.struts.StrutsUtils;
import org.apache.struts.action.ActionForward;
import jim.util.struts.JimActionErrors;
import jim.common.JimFatalException;
import java.io.IOException;
import javax.servlet.ServletException;
import org.apache.struts.validator.DynaValidatorForm;
import ivan.pums.assess.process.RegisterService;
import jim.common.Trace;
/**
 * Process Forgot password form submission
 * @author IVAN
 */
public class ForgotPassword extends PumsBaseAction {
    
    /** Creates a new instance of ForgotPassword */
    public ForgotPassword(){
    }
    
    /**
     * Action execution
     * @param su Jim App Struts Resources
     * @throws java.io.IOException IO Exception
     * @throws javax.servlet.ServletException Servlet Exception
     * @throws jim.common.JimFatalException Jim Fatal Exception
     * @return ActionForward
     */
    public ActionForward doPumsExecute(StrutsUtils su) throws IOException, ServletException, JimFatalException {
        if(su.getRequest().getMethod().equals("GET")){
            su.failure();
        }

        JimActionErrors errors = su.getErrors();
        DynaValidatorForm form = (DynaValidatorForm)su.getForm();
        errors.add(form.validate(su.getMapping(), su.getRequest()));
        
        if (!errors.isEmpty()) {
            return su.getMapping().findForward("failure");
        }

        try{
            String first_name = su.getRequest().getParameter("first_name");
            String surname = su.getRequest().getParameter("surname");
            String hemis = su.getRequest().getParameter("hemis");
            String email = su.getRequest().getParameter("email");
            
            if(hemis.length()==0&&email.length()==0){
                errors.addGlobal("regForm.errors.inputreq","");
                return su.getMapping().findForward("failure");
            }
            
            RegisterService ps = new RegisterService(su.getConn());
            
            if(hemis.length()==0){
                //Trace.print("Check forgot pw by email");
                if(!ps.forgotPwByEmail(first_name,surname,email)){errors.addGlobal("regForm.errors.forgotpwfail","");}//research email
            } else {
                if(email.length()==0){
                    if(!ps.forgotPwByHemis(first_name,surname,hemis)){errors.addGlobal("regForm.errors.forgotpwfail","");}//reserch hemis
                }else{
                    if(!ps.forgotPwByEmailHemis(first_name,surname,email,hemis)){errors.addGlobal("regForm.errors.forgotpwfail","");}//research both
                }
            }
        } catch (Exception e) {
            errors.addGlobal("pums.errors.dberror", "Could not Search information" + ": " + e.getMessage());
        }
        
        return su.successOrFailure();
    }
    
}

