/*
 * RegisterActionSubmit.java
 *
 * Created on 2006~0105 P, W10:26
 */

package ivan.pums.assess.actions;

import java.sql.SQLException;
import java.io.IOException;
import javax.servlet.ServletException;
import org.apache.struts.action.ActionForward;
import jim.pums.actions.PumsBaseAction;
import jim.util.struts.StrutsUtils;
import jim.util.struts.JimActionErrors;
import jim.common.JimFatalException;
import ivan.pums.assess.process.RegisterService;
import ivan.pums.assess.bus.AssessRegisterForm;

/**
 * Process Registration submission
 * @author IVAN
 */
public class RegisterActionSubmit extends PumsBaseAction {
    
    public RegisterActionSubmit() {
    }
    /**
     * Action execution
     * @param su Jim App Struts Resources
     * @throws java.io.IOException IO Exception
     * @throws javax.servlet.ServletException Servlet Exception
     * @throws jim.common.JimFatalException Jim Fatal Exception
     * @return ActionForward
     */
    public ActionForward doPumsExecute(StrutsUtils su) throws IOException, ServletException, JimFatalException {

        JimActionErrors errors = su.getErrors();
        AssessRegisterForm form = (AssessRegisterForm)su.getForm();
        
        errors.add(form.validate(su.getMapping(), su.getRequest()));
       
        if (!errors.isEmpty()) {
            return su.getMapping().findForward("failure");
        }
        RegisterService ps = new RegisterService(su.getConn());
        try {
            
            errors.add(ps.checkRegister(form));
            if (!errors.isEmpty()) {
                return su.getMapping().findForward("failure");
            }else{
                //su.beginTransaction();
                ps.addRegister(form);
                su.setAttribute("user", form, StrutsUtils.SESSION_SCOPE);
                //su.endTransaction();
            }

        } catch (Exception e) {
            errors.addGlobal("pums.errors.dberror", "Could not insert user " + form.getUser_name() + ": " + e.getMessage());
        }
        
        return su.successOrFailure();
    }
    
}
