/*
 * UserManagement.java
 *
 * Created on 2006~0214 PG, W9:18
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ivan.pums.assess.actions;

import java.util.Collections;
import jim.pums.actions.PumsBaseAction;
import jim.util.struts.StrutsUtils;
import org.apache.commons.collections.CollectionUtils;
import org.apache.struts.action.ActionForward;
import jim.util.struts.JimActionErrors;
import jim.common.JimFatalException;
import java.io.IOException;
import javax.servlet.ServletException;
import ivan.pums.assess.process.RegisterService;
import ivan.pums.assess.process.UserManagementService;
import ivan.pums.assess.bus.UserDetail;
import java.util.List;
import java.util.ArrayList;
import ivan.pums.assess.process.Logger;

import jim.common.Trace;
/**
 * Generate User Management page
 * @author IVAN
 */
public class UserManagement extends PumsBaseAction { 
    /** Creates a new instance of UserManagement */
    public UserManagement() {
    }
    /**
     * Action execution
     * @param su Jim App Struts Resources
     * @throws java.io.IOException IO Exception
     * @throws javax.servlet.ServletException Servlet Exception
     * @throws jim.common.JimFatalException Jim Fatal Exception
     * @return ActionForward
     */
    public ActionForward doPumsExecute(StrutsUtils su) throws IOException, ServletException, JimFatalException {
        JimActionErrors errors = su.getErrors();

        if (!errors.isEmpty()) {
            return su.getMapping().findForward("failure");
        }
        
        try{
            RegisterService rs = new RegisterService(su.getConn());
            UserManagementService us = new UserManagementService(su.getConn());
            Logger logger = new Logger(su.getSqlUtils());
            su.setAttribute("degreeStreams", rs.getDegreeStream(), StrutsUtils.SESSION_SCOPE);
            su.setAttribute("allroles", us.getRolesList(), StrutsUtils.SESSION_SCOPE);
            
            String act="";
            String state="";
            int page=1;
            int no=0;
            int numberperpage=10;
            
            state = su.getRequest().getParameter("state");
            List<UserDetail> users = new ArrayList<UserDetail>();
            
            if(su.getRequest().getParameter("ACTION")!=null){
                act = su.getRequest().getParameter("ACTION");
            }
            if(su.getRequest().getParameter("PAGE")!=null){
                page = Integer.valueOf(su.getRequest().getParameter("PAGE"));
            }

            if(act.equals("")||act.equals("ALL")){
                users=us.getAllDetail();
                su.setAttribute("currentpage",page,StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("numberperpage",numberperpage,StrutsUtils.REQUEST_SCOPE);
                no=users.size();
                su.setAttribute("pages",page(no,numberperpage),StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("allocations", users, StrutsUtils.REQUEST_SCOPE);
                su.closeConn();
            }
            if(act.equals("DEL")){
                String id = su.getRequest().getParameter("ID");
                Trace.print("USER Management: DELETE ID:" +id);
                rs.deleteWholePerson(Integer.valueOf(id));
                //logger.log(su.getRequest().getUserPrincipal().getName(),-1,"No reason now",id, id, "NA");
                logger.log(us.getIdByUser_name(su.getRequest().getRemoteUser()),Integer.valueOf(id),"No reason now","DEL_ACC", id, "NA");
                
                users=us.getAllDetail();
                su.setAttribute("currentpage",page,StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("numberperpage",numberperpage,StrutsUtils.REQUEST_SCOPE);
                no=users.size();
                su.setAttribute("pages",page(no,numberperpage),StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("allocations", users, StrutsUtils.REQUEST_SCOPE);
                return su.getMapping().findForward("deleted");
            }
            if(act.equals("SEARCH")){
                String hemis = su.getRequest().getParameter("hemis");
                String user_name = su.getRequest().getParameter("user_name");
                String first_name = su.getRequest().getParameter("first_name");
                String surname = su.getRequest().getParameter("surname");
                String email = su.getRequest().getParameter("email");
                String telephone = su.getRequest().getParameter("telephone");
                String degree_stream= su.getRequest().getParameter("degree_stream");
                String final_year = su.getRequest().getParameter("final_year");
                String roles[] = su.getRequest().getParameterValues("roles");
                users = us.searchUser(hemis, user_name, first_name, surname, email, telephone, degree_stream, final_year, roles);
                //Collections.binarySearch(users,);
                String urlextend = "&ACTION=SEARCH&hemis="+hemis+"&user_name="+user_name+"&first_name="+first_name+"&surname="+surname+"&email="+email+"&telephone="+telephone+"&degree_stream="+degree_stream
                        +"&final_year="+final_year;
                if(roles!=null){for(int i=0;i<roles.length;i++){urlextend+="&roles="+roles[i];}}
                
                su.setAttribute("url",urlextend,StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("currentpage",page,StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("numberperpage",numberperpage,StrutsUtils.REQUEST_SCOPE);
                no=users.size();
                su.setAttribute("pages",page(no,numberperpage),StrutsUtils.REQUEST_SCOPE);
                su.setAttribute("allocations", users, StrutsUtils.REQUEST_SCOPE);

            }
            if(act.equals("EDIT")){
                int id = Integer.valueOf(su.getRequest().getParameter("ID"));
                UserDetail umf = us.getDetail(id);
                su.setAttribute("detail",umf,StrutsUtils.SESSION_SCOPE/*REQUEST_SCOPE*/);
                return su.getMapping().findForward("change");
            }
            if(state!=null){
                if(state.equals("updated")){return su.getMapping().findForward("updated");}
                if(state.equals("noupdate")){return su.getMapping().findForward("noupdate");}
            }
            
            su.closeConn();
        } catch (java.sql.SQLException e) {
            throw new JimFatalException("Cannot list users - database problem", e);
        }
        return su.successOrFailure();
    }
    
    public List<Integer> page(int no, int numberperpage){
        List<Integer> page = new ArrayList<Integer>();
        for(int i=1;i*numberperpage<=no+numberperpage-1;i++){
            page.add(i);
        }
        return page;
    }

}
