/*
 * Logger.java
 *
 * Created on 2006~0130 P@, U4:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ivan.pums.assess.process;
import jim.util.SqlUtils;
import java.sql.SQLException;
import java.util.Date;
import ivan.pums.assess.useful.SqlTools;
/**
 * Handle Logger to Database
 * @author IVAN
 */
public class Logger {
    private SqlUtils sql = null;
    private SqlTools dbt = null;
    /** Creates a new instance of Logger */
    public Logger(SqlUtils sql) {
        this.sql = sql;
        dbt = new SqlTools(sql);
    }
    
    private static final String auditFields =
            "AUDIT_ID, " +
            "PERSON_MAKING_CHANGE_ID, " +
            "PROJECT_BEING_CHANGED_ID, " +
            "REASON, " +
            "DATE_ALTERED, " +
            "ITEM_CHANGED, " +
            "OLD_VALUE_OF_ITEM, " +
            "NEW_VALUE_OF_ITEM, " +
            "TIME_ALTERED";
    
    public void log(int user, int project, String reason, String item, String oldVal, String newVal) throws SQLException {
        if (reason == null || reason.equals("")){
            reason="No reason";
        }
        
        if (oldVal == null || oldVal.equals("")){
            oldVal="Null";
        }
        if (newVal == null || newVal.equals("")){
            newVal="Null";
        }
        if (!oldVal.equals(newVal)) {
            Date now = new Date();
            String insert = "INSERT INTO AUDIT_TRAIL (" + auditFields + ") " +
                    "VALUES(?, ?, ?, ?, ?, ?, ?, ?, ?)";
            sql.doExecute(insert, new Object[]{
                dbt.getNextID("AUDIT_ID","AUDIT_TRAIL"),
                        user,
                        project,
                        reason,
                        sql.dateParam(now),
                        sql.stringParam(item, 128),
                        sql.clobParam(oldVal),
                        sql.clobParam(newVal),
                        sql.timeStampParam(now)
            });
        }
    }
}
