/*
 * RegisterService.java
 *
 * Created on 2006~0104 PT, W10:33
 */

package ivan.pums.assess.process;

import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import jim.util.SqlUtils;
import java.util.HashMap;
import java.sql.Connection;
import java.sql.SQLException;
import java.sql.ResultSet;
//import steve.pums.assess.bus.PersonBean;
//import steve.pums.assess.bus.StudentBean;
import ivan.pums.assess.bus.*;
import steve.pums.assess.process.EmailService;
import javax.mail.MessagingException;
import jim.common.JimFatalException;
import jim.util.struts.JimActionErrors;
import java.text.ParseException;
import ivan.pums.assess.bus.AssessRegisterForm;
import jim.common.Trace;
import org.apache.struts.util.LabelValueBean;
import ivan.pums.assess.useful.SqlTools;
import ivan.pums.assess.useful.TypeUtils;
import ivan.pums.assess.process.Logger;
//import steve.pums.assess.process.ProjectService;
//import java.util.Vector;
/**
 * Collection of methods for Registation
 * @author IVAN
 * @version
 */

public class RegisterService {
    private SqlUtils sql = null;
    private EmailService email = null;
    private SqlTools dbt = null;
    private TypeUtils tutils = new TypeUtils();

    public RegisterService(SqlUtils sql) {
        this.sql = sql;
        email = new EmailService(sql);
        dbt = new SqlTools(sql);
    }
    public RegisterService(Connection conn) {
        sql = new SqlUtils(conn);
        email = new EmailService(sql);
        dbt = new SqlTools(sql);
    }
    
    public JimActionErrors checkRegister(AssessRegisterForm form) throws SQLException{
        JimActionErrors err = new JimActionErrors();
        
        if(findPersonIdByUser_name(form.getUser_name()) != 0){
            err.add("user_name","regForm.errors.usernameexist","");
        }
        if(findPersonIdByHemis(Integer.valueOf(form.getHemis())) != 0){
            err.add("hemis","regForm.errors.hemisexist","");
        }
        int eid;
        for(int i=0;i<form.getEmail().length;i++){
            Trace.print("Checking Email: "+form.getEmail()[i]);
            eid = findPersonIdByEmail(form.getEmail()[i]).size();

            if(eid > 0){
                Trace.print("EMAIL repeated");
                err.add("email["+String.valueOf(i)+"]","regForm.errors.emailexist","");
            }
        }
        return err;
    }
    
    public AssessRegisterForm addRegister(AssessRegisterForm form) throws SQLException, ParseException, MessagingException, JimFatalException {
        Logger logger = new Logger(sql);

        PersonBean user = new PersonBean();
        user.setFirst_name(form.getFirst_name());
        user.setSurname(form.getSurname());
        user.setUser_name(form.getUser_name());
        user.setPwd(form.getPassword1());
        addPerson(user);    //ADD Person to db
        form.setPerson_id(user.getPerson_id()); //return person_id to form
        
        addPersonRole(form.getPerson_id(),2,form.getUser_name());  //add PersonRole as 2
        
        StudentBean student = new StudentBean(); 
        student.setHemis_no(Integer.valueOf(form.getHemis()));
        student.setPerson_id(form.getPerson_id());
        student.setDegree_stream(form.getDegreeStream());
        student.setFinal_year(form.getFinal_year());
        addStudent(form.getPerson_id(),student); //ADD Student to db
        form.setStudent_id(student.getStudent_id());    //return Student ID to form

        addEmails(form.getPerson_id(),tutils.array2list(form.getEmail()));
        
        if(form.getTel_number().length>0&&form.getTel_number()[0].length()>0){addTel_numbers(form.getPerson_id(),tutils.array2list(form.getTel_number()));} //ADD Tel_numbers to db}
        
        form.setCode(genActiveCode(form.getPerson_id()));
        
        int[] pid= new int[]{form.getPerson_id()};
        email.setEmailTestOnly(true);
        email.sendEmail(pid, "REGCONF", form.getRegisterMap());
        
        logger.log(form.getPerson_id(),form.getPerson_id(),form.getReason() ,"Registration","",form.getUser_name());
        return form;
    }
    
 
    
    public PersonBean addPerson(PersonBean person) throws SQLException {
        
        String insert = "INSERT INTO person "
                + "(person_id, user_name, first_name, surname, pwd, inactive) "
                + "VALUES (?, ?, ?, ?, ?, ?) ";
        
        person.setPerson_id(dbt.getNextID("person_id","person"));
        person.setInactive(true);
        String inactive = person.getInactive()?"Y":"";
        sql.doExecute(insert, new Object[] {
            sql.intParam(person.getPerson_id()),
                    person.getUser_name(),
                    person.getFirst_name(),
                    person.getSurname(),
                    person.getPwd(),
                    new String(inactive)
        });
        return person;
    }
    
    public StudentBean addStudent(int person_id, StudentBean student) throws SQLException {
        String insert = "INSERT INTO student " +
                "(student_id, hemis_no, person_id, degree_stream, final_year) " +
                "VALUES (?, ?, ?, ?, ?)";
        student.setStudent_id(dbt.getNextID("student_id","student"));
        
        sql.doExecute(insert, new Object[] {
            student.getStudent_id(),
            sql.intParam(student.getHemis_no()),
            sql.intParam(person_id),
            student.getDegree_stream(),
            student.getFinal_year()
        });
        return student;
    }
    
    public void addPersonRole(int person_id, Integer role, String user_name) throws SQLException {
        String insert = "INSERT INTO person_roles (USER_NAME ,ROLE, PERSON_ID) VALUES (?, ?, ?)";
        sql.doExecute(insert, new Object[] {sql.stringParam(user_name,16),sql.intParam(role), sql.intParam(person_id)});
    }
    
    public void addTel_number(int person_id, String tel_number) throws SQLException {
        int telephone_number_id = dbt.getNextID("telephone_number_id","tel_number");
        String insert = "INSERT INTO tel_number (telephone_number_id, person_id, tel_number) VALUES (?, ?, ?)";
        sql.doExecute(insert, new Object[] {sql.intParam(telephone_number_id), sql.intParam(person_id), sql.stringParam(tel_number,20)});
    }
    
    public void addTel_numbers(int person_id, List<String> tel_numbers) throws SQLException {
        String select = "SELECT TELEPHONE_NUMBER_ID, PERSON_ID, TEL_NUMBER " +
                "FROM TEL_NUMBER " +
                "WHERE PERSON_ID = ?";
        ResultSet rs = sql.selectRSmod(select, new Object[]{sql.intParam(person_id)});
        while (rs.next()) {
            rs.deleteRow();
        }
        Iterator<String> it = tel_numbers.iterator();
        while (it.hasNext()) {
            String tel_number = it.next();
            rs.moveToInsertRow();
            int id = dbt.getNextID("TELEPHONE_NUMBER_ID","TEL_NUMBER");
            rs.updateInt(1, id);
            rs.updateInt(2, person_id);
            rs.updateString(3, tel_number);
            rs.insertRow();
        }
    }
    
    public boolean addEmails(int person_id, List<String>emailAddresses) throws SQLException, ParseException, MessagingException, JimFatalException {
        boolean ok = false;
        String select = "SELECT E_MAIL_ID, PERSON_ID, E_MAIL_ADD, E_MAIL_SUSPENDED " +
                "FROM PERSON_EMAIL " +
                "WHERE PERSON_ID = ?";
        ResultSet rs = sql.selectRSmod(select, new Object[]{sql.intParam(person_id)});
        while (rs.next()) {
            rs.deleteRow();
        }
        Iterator<String> it = emailAddresses.iterator();
        while (it.hasNext()) {
            String email = it.next();
            rs.moveToInsertRow();
            int id = dbt.getNextID("E_MAIL_ID","PERSON_EMAIL");
            rs.updateInt(1, id);
            rs.updateInt(2, person_id);
            rs.updateString(3, email);
            rs.updateNull(4);
            rs.insertRow();
        }
        ok = true;
        return ok;
    }

    public void setActive(int person_id) throws SQLException {
        String update = "UPDATE PERSON SET INACTIVE = NULL "
                + "WHERE PERSON_ID = ? "
                + "LIMIT 1";
        sql.doExecute(update, new Object[] {
            sql.intParam(person_id)
        });
    }
    
    public void setInactive(int person_id) throws SQLException {
        String update = "UPDATE PERSON SET INACTIVE = Y "
                + "WHERE PERSON_ID = ? "
                + "LIMIT 1";
        sql.doExecute(update, new Object[] {
            sql.intParam(person_id)
        });
    }
    public String genActiveCode(int person_id) throws SQLException {
        String code = sql.randomKey(8);
        String insert = "INSERT INTO ACTIVATION (person_id, code) VALUES (?, ?)";
        sql.doExecute(insert, new Object[] {sql.intParam(person_id), code});
        Trace.print("Generated code: " + code);
        return code;
    }
    
    public String getActiveCode(int person_id) throws SQLException {
        String code = "";
        String select = "SELECT CODE FROM ACTIVATION WHERE PERSON_ID = ? LIMIT 1";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        if (rs.last())
        {
            code = rs.getString(1);
        }
        return code;
    }
    
    public int getPersonIdByCode(String code) throws SQLException {
        int id = 0;
        if (code == null || code.equals("")) {return id;}
        String select = "SELECT PERSON_ID FROM ACTIVATION WHERE CODE = ? LIMIT 1";
        ResultSet rs = sql.selectRS(select, new Object[]{code});
        if (rs.last()){id = rs.getInt(1);}
        return id;
    }

    public void delActiveCode(int person_id) throws SQLException {
        String delete = "DELETE FROM ACTIVATION WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
    }
    
    public int findPersonIdByHemis(int hemis) throws SQLException {
        int id = 0;
        String select = "SELECT PERSON_ID FROM STUDENT WHERE HEMIS_NO = ? LIMIT 1";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(hemis)});
        if (!rs.last()) {
            return id;
        }else{
            id = rs.getInt(1);
            return id;
        }
    }    

    public int findPersonIdByUser_name(String username) throws SQLException {
        int id = 0;
        String select = "SELECT PERSON_ID FROM PERSON WHERE USER_NAME = ? LIMIT 1";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.stringParam(username,16)});
        if (!rs.last()) {
            return id;
        }else{
            id = rs.getInt(1);
            return id;
        }
    }

    public List<Integer> findPersonIdByEmail(String email) throws SQLException {
        List<Integer> id = new ArrayList<Integer>();

        String select = "SELECT PERSON_ID FROM PERSON_EMAIL WHERE E_MAIL_ADD = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.stringParam(email,50)});
        //rs.first();
        while (rs.next()) {
            id.add(rs.getInt(1));
        }
            return id;
    }
    
    public List<PersonBean> getAllPersons() throws SQLException {
        List<PersonBean> persons = new ArrayList<PersonBean>();
        
        String select = "SELECT P.PERSON_ID, P.USER_NAME, P.PWD, P.FIRST_NAME, P.SURNAME, P.INACTIVE FROM PERSON P "
                + "ORDER BY P.PERSON_ID";
        
        ResultSet rs = sql.selectRS(select);
        
        while (rs.next()) {
            PersonBean person = new PersonBean(rs.getInt(1),  rs.getString(2) , rs.getString(3), rs.getString(4), rs.getString(5),rs.getBoolean(6));
            persons.add(person);
        }        
        return persons;
    }
    
    public void deleteWholePerson(int person_id) throws SQLException {
        String delete = "DELETE FROM PERSON WHERE PERSON_ID = ? LIMIT 1";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
        delete = "DELETE FROM TEL_NUMBER WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
        delete = "DELETE FROM PERSON_EMAIL WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
        delete = "DELETE FROM PERSON_ROLES WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
        delete = "DELETE FROM STUDENT WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
        delete = "DELETE FROM ACTIVATION WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_id)});
    }
    
    public boolean forgotPwByEmail(String first_name,String surname, String emailaddr) throws SQLException, JimFatalException, MessagingException{
        boolean found = false;
        String select = "SELECT P.PERSON_ID PERSON_ID, P.USER_NAME USERNAME, P.PWD PASSWORD FROM PERSON P, PERSON_EMAIL E " + 
                        "WHERE P.FIRST_NAME = ? AND P.SURNAME = ? AND E.E_MAIL_ADD = ? " +
                        "AND P.PERSON_ID = E.PERSON_ID";
        ResultSet rs = sql.selectRS(select, new Object[]{first_name,surname,emailaddr});
        if (rs.last()) {
            HashMap args = new HashMap();
            args.put("USERNAME",rs.getString(2));
            args.put("PASSWORD",rs.getString(3));
            int[] pid = new int[]{rs.getInt(1)};
            email.setEmailTestOnly(true);
            email.sendEmail(pid, "FORGOTPW", args);
            found=true;
        }
        return found;
    }
    public boolean forgotPwByHemis(String first_name,String surname, String hemis) throws SQLException, JimFatalException, MessagingException{
        boolean found = false;
        String select = "SELECT P.PERSON_ID PERSON_ID, P.USER_NAME USERNAME, P.PWD PASSWORD FROM PERSON P, STUDENT S " + 
                        "WHERE P.FIRST_NAME = ? AND P.SURNAME = ? AND S.HEMIS_NO = ? " +
                        "AND P.PERSON_ID = S.PERSON_ID";
        ResultSet rs = sql.selectRS(select, new Object[]{first_name,surname,hemis});
        if (rs.last()) {
            HashMap args = new HashMap();
            args.put("USERNAME",rs.getString(2));
            args.put("PASSWORD",rs.getString(3));
            int[] pid = new int[]{rs.getInt(1)};
            email.setEmailTestOnly(true);
            email.sendEmail(pid, "FORGOTPW", args);
            found=true;
        }
        return found;
    }
    public boolean forgotPwByEmailHemis(String first_name,String surname, String emailaddr, String hemis) throws SQLException, JimFatalException, MessagingException{
        boolean found = false;
        String select = "SELECT P.PERSON_ID PERSON_ID, P.USER_NAME USERNAME, P.PWD PASSWORD FROM PERSON P, PERSON_EMAIL E, STUDENT S " + 
                        "WHERE P.FIRST_NAME = ? AND P.SURNAME = ? AND S.HEMIS_NO = ? AND E.E_MAIL_ADD = ? " +
                        "AND P.PERSON_ID = S.PERSON_ID AND S.PERSON_ID = E.PERSON_ID";
        ResultSet rs = sql.selectRS(select, new Object[]{first_name,surname,hemis,emailaddr});
        if (rs.last()) {
            HashMap args = new HashMap();
            args.put("USERNAME",rs.getString(2));
            args.put("PASSWORD",rs.getString(3));
            int[] pid = new int[]{rs.getInt(1)};
            email.setEmailTestOnly(true);
            email.sendEmail(pid, "FORGOTPW", args);
            found=true;
        }
        return found;
    }
    
    
    
    public List getDegreeStream(){
        List degree = new ArrayList();
        degree.add(new LabelValueBean("Computer Science (CS)","CS"));
        degree.add(new LabelValueBean("Software Engineering (SE)","SE"));
        degree.add(new LabelValueBean("Business Information Systems (BIS)","BIS"));
        degree.add(new LabelValueBean("Business Information Technology (BIT)","BIT"));
        degree.add(new LabelValueBean("Computing and the Information Society (CIS, ex ITS)","CIS"));
        degree.add(new LabelValueBean("E-Commerce and Internet Systems (EIS)","EIS"));
        degree.add(new LabelValueBean("Internet Application Development (IAD)","IAD"));
        degree.add(new LabelValueBean("Information Systems & Networks (ISN)","ISN"));
        degree.add(new LabelValueBean("Information Systems (IS)","IS"));
        degree.add(new LabelValueBean("Intelligent Systems (ISY)","ISY"));
        degree.add(new LabelValueBean("Database Technologies (DBT)","DBT"));
        degree.add(new LabelValueBean("Computing (CMP)","CMP"));
        degree.add(new LabelValueBean("Computer Sciences (direct entry)","CSS"));
        return degree;
    }
}
