/*
 * UserManagementService.java
 *
 * Created on 2006~0214 PG, U7:06
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ivan.pums.assess.process;

import ivan.pums.assess.bus.UserDetail;
import jim.common.JimFatalException;
import jim.util.struts.JimActionErrors;
import java.text.ParseException;
import java.sql.SQLException;
import ivan.pums.assess.useful.SqlTools;
import steve.pums.assess.process.EmailService;
import jim.util.SqlUtils;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Map;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
import ivan.pums.assess.useful.SqlTools;
import java.util.Vector;
import ivan.pums.assess.bus.*;
import ivan.pums.assess.process.RegisterService;
import ivan.pums.assess.process.Logger;
import jim.common.Trace;
/**
 * Collection of methods for User Management
 * @author IVAN
 */
public class UserManagementService {
    private SqlUtils sql = null;
    private EmailService email = null;
    private SqlTools dbt = null;
    private Logger logger = null;
    private RegisterService rs = null;
    /** Creates a new instance of UserManagementService */
    public UserManagementService(SqlUtils sql) {
        this.sql = sql;
        email = new EmailService(sql);
        dbt = new SqlTools(sql);
        logger = new Logger(sql);
        rs = new RegisterService(sql);
    }
    public UserManagementService(Connection conn) {
        sql = new SqlUtils(conn);
        email = new EmailService(sql);
        dbt = new SqlTools(sql);
        logger = new Logger(sql);
        rs = new RegisterService(conn);
    }
    
    public void updateUserDetail(UserDetail user) throws SQLException{
        user.setPerson_detail();
        
        updatePerson(user.getPerson());
        if(user.getPassword1().equals(user.getPassword2())&&!user.getPassword1().equals("")){
            updatePersonPwd(user.getPerson().getPerson_id(),user.getPassword1());
        }
        updatePerson_roles(user.getPerson_roles());
        updatePerson_emails(user.getPerson_emails());
        updateTel_numbers(user.getTel_numbers());
        updateStudent(user.getStudent());
        /*Check staff first*/
        //updateStaff(user.getStaff());
    }
    
    public JimActionErrors checkUserDetail(UserDetail user) throws SQLException{
        JimActionErrors err = new JimActionErrors();
        
//        if(rs.findPersonIdByUser_name(user.getPerson().getUser_name()) != 0){
//            err.add("user_name","regForm.errors.usernameexist","");
//        }
        if (user==null){err.add("error","usermanagement.errors.nodata","");return err;}
//        Trace.print("USERNMAE++++++: "+user.getPerson().getUser_name());
//        Trace.print("USERID++++++: "+user.getPerson().getPerson_id());
        if(rs.findPersonIdByUser_name(user.getPerson().getUser_name()) != user.getPerson().getPerson_id()){
            err.add("error","usermanagement.errors.datamismatch","");
        }
        
//        if(rs.findPersonIdByHemis(Integer.valueOf(user.getStudent().getHemis_no())) != 0){
//            err.add("hemis","regForm.errors.hemisexist","");
//        }
//        int eid;
//        for(int i=0;i<user.getPerson_emails().size();i++){
//            //Trace.print("Checking Email: "+form.getEmail()[i]);
//            eid = rs.findPersonIdByEmail(user.getPerson_emailsIndexed(i).getE_mail_add()).size();
//
//            if(eid > 0){
//                Trace.print("EMAIL repeated");
//                err.add("email["+String.valueOf(i)+"]","regForm.errors.emailexist","");
//            }
//        }
        return err;
    }
    
    public PersonBean getPerson(int person_id) throws SQLException{
        PersonBean person = null;
        //table include: person, person_roles--roles, staff, student, tel_number, person_email
        String select = "SELECT P.PERSON_ID, P.USER_NAME, P.PWD, P.FIRST_NAME, P.SURNAME, P.INACTIVE FROM PERSON P"
                + " WHERE P.PERSON_ID = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        if (rs.last()) {
            person = new PersonBean(rs.getInt(1),  rs.getString(2) , rs.getString(3), rs.getString(4), rs.getString(5), rs.getBoolean(6));
        }
        return person;
    }
    
    public void updatePerson(PersonBean person) throws SQLException{
        String update = "UPDATE PERSON SET USER_NAME = ?, " + //update without update person_id and pwd
                "FIRST_NAME = ?, SURNAME = ?, INACTIVE = ? WHERE PERSON_ID = ?";
        sql.doExecute(update, new Object[] {
            sql.stringParam(person.getUser_name(),16),
            //sql.stringParam(person.getPwd(),16),
            sql.stringParam(person.getFirst_name(),64),
            sql.stringParam(person.getSurname(),64),
            person.getInactive()?"Y":null,
            sql.intParam(person.getPerson_id())
        });
    }
    
    public void updatePersonPwd(int person_id, String pwd) throws SQLException{
        String update = "UPDATE PERSON SET PWD = ? WHERE PERSON_ID = ?";
        sql.doExecute(update, new Object[]{sql.stringParam(pwd,16),sql.intParam(person_id)});
    }
    
    public Map<Integer, String> getRolesMap() throws SQLException {
        String select = "SELECT role_id, role_description FROM roles ORDER BY role_id";
        ResultSet rs = sql.selectRS(select);
        HashMap<Integer, String> roles = new HashMap<Integer, String>();
        while (rs.next()) {
            Integer id = rs.getInt(1);
            String desc = rs.getString(2);
            roles.put(id, desc);
        }
        return roles;
    }
    
    public List<RolesBean> getRolesList() throws SQLException {
        String select = "SELECT role_id, role_description FROM roles ORDER BY role_id";
        ResultSet rs = sql.selectRS(select);
        List<RolesBean> roles = new ArrayList<RolesBean>();
        while (rs.next()) {
            RolesBean role = new RolesBean(rs.getInt(1), rs.getString(2));
            roles.add(role);
        }
        return roles;
    }
    
    public List<Person_RolesBean> getPerson_roles(int person_id) throws SQLException {
        List<Person_RolesBean> person_roles = new ArrayList<Person_RolesBean>();
        String select = "SELECT R.PERSON_ID, R.ROLE, O.ROLE_DESCRIPTION, R.USER_NAME FROM PERSON_ROLES R, ROLES O"
                + " WHERE R.PERSON_ID = ? AND R.ROLE = O.ROLE_ID ORDER BY R.ROLE";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        while (rs.next()) {
            Person_RolesBean person_role = new Person_RolesBean(rs.getInt(1),rs.getInt(2),rs.getString(3),rs.getString(4));
            person_roles.add(person_role);
            Trace.print("GetRole: PersonID:" + person_role.getPerson_id() + " Role:" + person_role.getRole());
        }
//        Person_RolesBean[] a = new Person_RolesBean[]{};
//        Person_RolesBean[] all = (Person_RolesBean[])person_roles.toArray(a);
        
/*        int size = person_roles.size();
        Person_RolesBean[] all = new Person_RolesBean[size];
        for (int i=0;i<size;i++){all[i]=person_roles.get(i);
            Trace.print("GetRole: PersonID:" + all[i].getPerson_id() + " Role:" + all[i].getRole());
        }*/
        return person_roles;
    }
    
    public void updatePerson_roles(List<Person_RolesBean> person_roles) throws SQLException{
/*        for(int i=0;i=person_roles.length;i++){
            String update = "UPDATE PERSON_ROLES SET ROLE = ?, USER_NAME = ?" +
                    " WHERE PERSON_ID = ?";
            sql.doExecute(update, new Object[] {
                sql.intParam(person_roles.getRole());
                sql.stringParam(person_roles.getUser_name(),16),
            });
            Trace.print("UPDATE DATBASE DATA DETAIL: username="+person.getUser_name());
        }*/
        
        /*String select = "SELECT PERSON_ID, USER_NAME, ROLE " +
                "FROM PERSON_ROLES " +
                "WHERE PERSON_ID = ?";
        if(person_roles.isEmpty()){return;}
        ResultSet rs = sql.selectRSmod(select, new Object[]{sql.intParam(person_roles.get(0).getPerson_id())});
        while (rs.next()) {
            rs.deleteRow();
        }*/
        if(person_roles.isEmpty()){return;}
        String delete = "DELETE FROM PERSON_ROLES WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(person_roles.get(0).getPerson_id())});
        int len = person_roles.size();
        Trace.print("Length of Array Person role: " + len);
        for (int i=0;i<len;i++){
            if(person_roles.get(i).getRole()!=0){
                String insert = "INSERT INTO person_roles (USER_NAME, ROLE, PERSON_ID) VALUES (? , ?, ?)";
                sql.doExecute(insert, new Object[] {sql.stringParam(person_roles.get(i).getUser_name(),16),sql.intParam(person_roles.get(i).getRole()), sql.intParam(person_roles.get(i).getPerson_id())});
            }
        }
    }
    
    public List<Person_EmailBean> getPerson_emails(int person_id) throws SQLException {
        List<Person_EmailBean> person_emails = new ArrayList<Person_EmailBean>();
        String select = "SELECT E.PERSON_ID, E.E_MAIL_ID, E.E_MAIL_ADD, E.E_MAIL_SUSPENDED FROM PERSON_EMAIL E"
                + " WHERE E.PERSON_ID = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        while (rs.next()) {
            Person_EmailBean person_email = new Person_EmailBean(rs.getInt(1),rs.getInt(2),rs.getString(3),rs.getBoolean(4));
            person_emails.add(person_email);
            Trace.print("email retrieved: "+person_email.getE_mail_add());
        }
//        Person_EmailBean[] a = new Person_EmailBean[]{};
//        Person_EmailBean[] all = (Person_EmailBean[])person_emails.toArray(a);
        return person_emails;
    }
    
    public void updatePerson_emails(List<Person_EmailBean> person_emails) throws SQLException{
//        String select = "SELECT E_MAIL_ID " +
//                "FROM PERSON_EMAIL " +
//                "WHERE PERSON_ID = ?";
        String delete = "DELETE FROM PERSON_EMAIL WHERE PERSON_ID = ?";
        if(person_emails.isEmpty()){return;}
        sql.doExecute(delete, new Object[]{sql.intParam(person_emails.get(0).getPerson_id())});
//        while (rs.next()) {
//            rs.deleteRow();
//        }
        int len = person_emails.size();
        Trace.print("Length of Array Person email: " + len);
        for (int i=0;i<len;i++){
            String insert = "INSERT INTO person_email (E_MAIL_ID, PERSON_ID, E_MAIL_ADD, E_MAIL_SUSPENDED) VALUES (?, ?, ?, ?)";
            if(person_emails.get(i).getE_mail_add()!=null&&!person_emails.get(i).getE_mail_add().equals("")){
                sql.doExecute(insert, new Object[] {dbt.getNextID("E_MAIL_ID","PERSON_EMAIL"), sql.intParam(person_emails.get(i).getPerson_id()),sql.stringParam(person_emails.get(i).getE_mail_add(),128),person_emails.get(i).getE_mail_suspended()?"Y":null});
            }
        }
    }
    
    public StaffBean getStaff(int person_id) throws SQLException{
        StaffBean staff = null;
        String select = "SELECT S.PERSON_ID, S.STAFF_NO FROM STAFF S"
                + " WHERE S.PERSON_ID = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        if (rs.last()) {
            staff = new StaffBean(rs.getInt(1),  rs.getString(2));
        }
        return staff;
    }
    
    public void updateStaff(StaffBean staff) throws SQLException{
        if(staff!=null){
            String select = "SELECT * FROM STAFF WHERE PERSON_ID = ?";
            ResultSet rs = sql.selectRS(select,new Object[]{sql.intParam(staff.getPerson_id())});
            if(!rs.first()){
                addStaff(staff);
            }else{
                String update = "UPDATE STAFF SET STAFF_NO = ?" +
                        " WHERE PERSON_ID = ?";
                if (staff.getStaff_no()!=null||!staff.getStaff_no().equals("")){
                    sql.doExecute(update, new Object[] {sql.stringParam(staff.getStaff_no(),16),sql.intParam(staff.getPerson_id())});
                }else{
                    deleteStaff(staff);
                }
            }
        }
    }
    
    public void deleteStaff(StaffBean staff) throws SQLException {
        String delete = "DELETE FROM STAFF WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(staff.getPerson_id())});
    }
    public void addStaff(StaffBean staff) throws SQLException {
        String insert = "INSERT INTO STAFF (STAFF_NO, PERSON_ID) VALUES (?, ?)";
        sql.doExecute(insert, new Object[] {sql.stringParam(staff.getStaff_no(),16), sql.intParam(staff.getPerson_id())});
    }
    
    public StudentBean getStudent(int person_id) throws SQLException{
        StudentBean student = null;
        String select = "SELECT S.PERSON_ID, S.STUDENT_ID, S.HEMIS_NO, S.DEGREE_STREAM, S.FINAL_YEAR FROM STUDENT S"
                + " WHERE S.PERSON_ID = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        if (rs.last()){
            student = new StudentBean(rs.getInt(1),rs.getInt(2),rs.getInt(3),rs.getString(4),rs.getString(5));
        }
        return student;
    }
    
    public void updateStudent(StudentBean student) throws SQLException{
        if(student != null){
            String select = "SELECT * FROM STUDENT WHERE PERSON_ID = ?";
            ResultSet rs = sql.selectRS(select,new Object[]{sql.intParam(student.getPerson_id())});
            if(!rs.first()){
                addStudent(student);
//                String insert = "INSERT INTO STUDENT " +
//                        "(student_id, hemis_no, person_id, degree_stream, final_year) " +
//                        "VALUES (?, ?, ?, ?, ?)";
//                sql.doExecute(insert, new Object[] {dbt.getNextID("STUDENT_ID","STUDENT"),sql.intParam(student.getHemis_no()),
//                        sql.intParam(student.getPerson_id()),sql.stringParam(student.getDegree_stream(),16),sql.stringParam(student.getFinal_year(),16)});
            }else{
                String update = "UPDATE STUDENT SET HEMIS_NO = ?, DEGREE_STREAM = ?, FINAL_YEAR = ?" +
                        " WHERE PERSON_ID = ?";
                sql.doExecute(update, new Object[] {sql.intParam(student.getHemis_no()),sql.stringParam(student.getDegree_stream(),16),sql.stringParam(student.getFinal_year(),16),sql.intParam(student.getPerson_id())});
            }
        }
    }
    public void deleteStudent(StudentBean student) throws SQLException {
        String delete = "DELETE FROM STUDENT WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[] {sql.intParam(student.getPerson_id())});
    }
    public void addStudent(StudentBean student) throws SQLException {
        String insert = "INSERT INTO STUDENT (STUDENT_ID, PERSON_ID, HEMIS_NO, DEGREE_STREAM, FINAL_YEAR) VALUES (?, ?, ?, ?, ?)";
        sql.doExecute(insert, new Object[] {dbt.getNextID("STUDENT_ID","STUDENT"),sql.intParam(student.getPerson_id()),sql.intParam(student.getHemis_no()),sql.stringParam(student.getDegree_stream(),16),sql.stringParam(student.getFinal_year(),16)});
    }
    
    public List<Tel_NumberBean> getTel_numbers(int person_id) throws SQLException{
        List<Tel_NumberBean> tel_numbers = new ArrayList<Tel_NumberBean>();
        String select = "SELECT T.PERSON_ID, T.TELEPHONE_NUMBER_ID, T.TEL_NUMBER FROM TEL_NUMBER T"
                + " WHERE T.PERSON_ID = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        while (rs.next()) {
            Tel_NumberBean tel_number = new Tel_NumberBean(rs.getInt(1),rs.getInt(2),rs.getString(3));
            tel_numbers.add(tel_number);
        }
//        Tel_NumberBean[] a = new Tel_NumberBean[]{};
//        Tel_NumberBean[] all = (Tel_NumberBean[])tel_numbers.toArray(a);
        
        return tel_numbers;
    }
    
    public void updateTel_numbers(List<Tel_NumberBean> tel_numbers) throws SQLException{
//        String select = "SELECT * " +
//                "FROM TEL_NUMBER " +
//                "WHERE PERSON_ID = ?";
//        ResultSet rs = sql.selectRSmod(select, new Object[]{sql.intParam(tel_numbers[0].getPerson_id())});
//        while (rs.next()) {
//            rs.deleteRow();
//        }
        if(tel_numbers.isEmpty()){return;}
        String delete = "DELETE FROM TEL_NUMBER WHERE PERSON_ID = ?";
        sql.doExecute(delete, new Object[]{sql.intParam(tel_numbers.get(0).getPerson_id())});
        
        int len = tel_numbers.size();
        Trace.print("Length of Array Person TEL_NUMBER: " + len);
        for (int i=0;i<len;i++){
            String insert = "INSERT INTO TEL_NUMBER (TELEPHONE_NUMBER_ID, PERSON_ID, TEL_NUMBER) VALUES (?, ?, ?)";
            if(tel_numbers.get(i).getTel_number()!=null&&!tel_numbers.get(i).getTel_number().equals("")){
                sql.doExecute(insert, new Object[] {dbt.getNextID("TELEPHONE_NUMBER_ID","TEL_NUMBER"), sql.intParam(tel_numbers.get(i).getPerson_id()),sql.stringParam(tel_numbers.get(i).getTel_number(),20)});
            }
        }
    }
    
    public UserDetail getDetail(int person_id) throws SQLException{
        UserDetail user = null;
        String select = "SELECT P.PERSON_ID, P.USER_NAME, P.PWD, P.FIRST_NAME, P.SURNAME, P.INACTIVE FROM PERSON P "
                + "WHERE P.PERSON_ID = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.intParam(person_id)});
        if (rs.last()){
            PersonBean person = new PersonBean(rs.getInt(1),  rs.getString(2) , rs.getString(3),rs.getString(4),rs.getString(5),rs.getBoolean(6));
            user = new UserDetail(person,getPerson_roles(person.getPerson_id()),getPerson_emails(person.getPerson_id()),getStudent(person.getPerson_id()),getStaff(person.getPerson_id()),getTel_numbers(person.getPerson_id()));
        }
        return user;
    }
    
    public List<UserDetail> getAllDetail() throws SQLException{
        List<UserDetail> users = new ArrayList<UserDetail>();
        String select = "SELECT P.PERSON_ID, P.USER_NAME, P.PWD, P.FIRST_NAME, P.SURNAME, P.INACTIVE FROM PERSON P "
                + "ORDER BY P.PERSON_ID";
        ResultSet rs = sql.selectRS(select);
        while (rs.next()) {
            PersonBean person = new PersonBean(rs.getInt(1),  rs.getString(2) , rs.getString(3),rs.getString(4),rs.getString(5),rs.getBoolean(6));
            UserDetail user = new UserDetail(person,getPerson_roles(person.getPerson_id()),getPerson_emails(person.getPerson_id()),getStudent(person.getPerson_id()),getStaff(person.getPerson_id()),getTel_numbers(person.getPerson_id()));
            users.add(user);
        }
        return users;
    }
    
    public int getIdByUser_name(String user_name) throws SQLException{
        int id=0;
        String select = "SELECT P.PERSON_ID FROM PERSON P "
                + "WHERE USER_NAME = ?";
        ResultSet rs = sql.selectRS(select, new Object[]{sql.stringParam(user_name,16)});
        if (rs.last()){
            id = rs.getInt(1);
        }
        return id;
    }
    
    public List<UserDetail> searchUser(String hemis, String user_name, String first_name, String surname, String email, String telephone, String degree_stream, String final_year, String[] roles) throws SQLException{
        boolean found = false;
        UserDetail user = new UserDetail();
        Iterator<UserDetail> users = getAllDetail().iterator();
        List<UserDetail> result = new ArrayList<UserDetail>();
        while (users.hasNext()) {
            found=false;
            user = users.next();
            if(user_name!=null){
                if(user.getPerson().getUser_name().equalsIgnoreCase(user_name)){found=true;}
            }
            if(first_name!=null){
                if(user.getPerson().getFirst_name().equalsIgnoreCase(first_name)){found=true;}
            }
            if(surname!=null){
                if(user.getPerson().getSurname().equalsIgnoreCase(surname)){found=true;}
            }
            if(hemis!=null){
                if(user.getStudent()!=null){
                    if(String.valueOf(user.getStudent().getHemis_no()).equalsIgnoreCase(hemis)){found=true;}
                }
            }
            if(email!=null){
                if(user.getPerson_emails()!=null){
                    for(int i=0;i<user.getPerson_emails().size();i++){
                        if(user.getPerson_emailsIndexed(i).getE_mail_add().equalsIgnoreCase(email)){found=true;}
                    }
                }
            }
            if(telephone!=null){
                if(user.getTel_numbers()!=null){
                    for(int i=0;i<user.getTel_numbers().size();i++){
                        if(user.getTel_numbersIndexed(i).getTel_number().equalsIgnoreCase(telephone)){found=true;}
                    }
                }
            }
            if(degree_stream!=null){
                if(user.getStudent()!=null){
                    if(user.getStudent().getDegree_stream().equalsIgnoreCase(degree_stream)){found=true;}
                }
            }
            if(final_year!=null){
                if(user.getStudent()!=null){
                    if(user.getStudent().getFinal_year().equalsIgnoreCase(final_year)){found=true;}
                }
            }
            if(roles!=null){
                if(user.getPerson_roles().size()>0){
                    for(int i=0;i<user.getPerson_roles().size();i++){
                        for(int j=0;j<roles.length;j++){
                            if(user.getPerson_rolesIndexed(i).getRole()==Integer.valueOf(roles[j])){found=true;}//user.getPerson_roles()[i].getRole_description().equalsIgnoreCase(roles[j])
                        }
                    }
                }
            }
            
            if(found){result.add(user);}
        }
        return result;
    }
    
    public boolean compareAndLog(UserDetail newvalue, UserDetail oldvalue, int person_making_id, String reason, int project) throws SQLException{ //return true if data changed
        boolean changed = false;
        if(newvalue.getPassword1().equals(newvalue.getPassword2())&&!newvalue.getPassword1().equals("")){
            logger.log(person_making_id,project,reason,"pwd",oldvalue.getPerson().getPwd(),newvalue.getPassword1());
            changed = true;
            //Trace.print("SET TRUE in pwd()()()()()()()");
        }
        if(!newvalue.getPerson().getFirst_name().equals(oldvalue.getPerson().getFirst_name())){
            logger.log(person_making_id,project,reason,"first_name",oldvalue.getPerson().getFirst_name(),newvalue.getPerson().getFirst_name());
            changed = true;
            //Trace.print("SET TRUE in first_name()()()()()()()");
        }
        if(!newvalue.getPerson().getSurname().equals(oldvalue.getPerson().getSurname())){
            logger.log(person_making_id,project,reason,"surname",oldvalue.getPerson().getSurname(),newvalue.getPerson().getSurname());
            changed = true;
            //Trace.print("SET TRUE in surname()()()()()()()");
        }
        if(!newvalue.getPerson().getUser_name().equals(oldvalue.getPerson().getUser_name())){
            logger.log(person_making_id,project,reason,"user_name",oldvalue.getPerson().getUser_name(),newvalue.getPerson().getUser_name());
            changed = true;
            //Trace.print("SET TRUE in user_name()()()()()()()");
        }
        if(newvalue.getPerson().getInactive()!=oldvalue.getPerson().getInactive()){
            logger.log(person_making_id,project,reason,"inactive",oldvalue.getPerson().getInactive()?"Y":"Null",newvalue.getPerson().getInactive()?"Y":"Null");
            changed = true;
            //Trace.print("SET TRUE in inactive()()()()()()()");
        }
        for(int i=0;i<newvalue.getPerson_roles().size();i++){
            if(newvalue.getPerson_rolesIndexed(i).getRole()!=oldvalue.getPerson_rolesIndexed(i).getRole()){
                logger.log(person_making_id,project,reason,"role",String.valueOf(oldvalue.getPerson_rolesIndexed(i).getRole()),String.valueOf(newvalue.getPerson_rolesIndexed(i).getRole()));
                changed = true;
                //Trace.print("SET TRUE in Roles()()()()()()()");
            }
        }
        for(int i=0;i<newvalue.getPerson_emails().size();i++){
            if(!newvalue.getPerson_emailsIndexed(i).getE_mail_add().equals(oldvalue.getPerson_emailsIndexed(i).getE_mail_add())){
                if(!(newvalue.getPerson_emailsIndexed(i).getE_mail_add().equals("")&&oldvalue.getPerson_emailsIndexed(i).getE_mail_add()==null)){
                    logger.log(person_making_id,project,reason,"e_mail_add",oldvalue.getPerson_emailsIndexed(i).getE_mail_add(),newvalue.getPerson_emailsIndexed(i).getE_mail_add());
                    changed = true;
                    //Trace.print("SET TRUE in email()()()()()()()");
                }
            }
            if(newvalue.getPerson_emailsIndexed(i).getE_mail_suspended()!=oldvalue.getPerson_emailsIndexed(i).getE_mail_suspended()){
                logger.log(person_making_id,project,reason,"e_mail_suspended",oldvalue.getPerson_emailsIndexed(i).getE_mail_suspended()?"Y":"Null",newvalue.getPerson_emailsIndexed(i).getE_mail_suspended()?"Y":"Null");
                changed = true;
                //Trace.print("SET TRUE in Email()()()()()()()");
            }
        }
        for(int i=0;i<newvalue.getTel_numbers().size();i++){
            if(!newvalue.getTel_numbersIndexed(i).getTel_number().equals(oldvalue.getTel_numbersIndexed(i).getTel_number())){
                if(!(newvalue.getTel_numbersIndexed(i).getTel_number().equals("")&&oldvalue.getTel_numbersIndexed(i).getTel_number()==null)){
                    logger.log(person_making_id,project,reason,"tel_number",oldvalue.getTel_numbersIndexed(i).getTel_number(),newvalue.getTel_numbersIndexed(i).getTel_number());
                    changed = true;
                    //Trace.print("SET TRUE in Tel_number()()()()()()()");
                }
            }
        }
        if(oldvalue.getStudent()==null){oldvalue.setStudent(new StudentBean());}
        if(!String.valueOf(newvalue.getStudent().getHemis_no()).equals(String.valueOf(oldvalue.getStudent().getHemis_no()))){
            logger.log(person_making_id,project,reason,"hemis_no",String.valueOf(oldvalue.getStudent().getHemis_no()),String.valueOf(newvalue.getStudent().getHemis_no()));
            changed = true;
            //Trace.print("SET TRUE in HEMIS()()()()()()()");
        }
        if((!newvalue.getStudent().getDegree_stream().equals(oldvalue.getStudent().getDegree_stream()))&&oldvalue.getStudent().getDegree_stream()!=null){
            logger.log(person_making_id,project,reason,"degree_stream",oldvalue.getStudent().getDegree_stream(),newvalue.getStudent().getDegree_stream());
            changed = true;
            //Trace.print("SET TRUE in degree_stream()()()()()()()");
        }
        if(!newvalue.getStudent().getFinal_year().equals(oldvalue.getStudent().getFinal_year())&&!(newvalue.getStudent().getFinal_year().equals("")&&oldvalue.getStudent().getFinal_year()==null)){
            logger.log(person_making_id,project,reason,"final_year",oldvalue.getStudent().getFinal_year(),newvalue.getStudent().getFinal_year());
            changed = true;
            //Trace.print("SET TRUE in Final_year()()()()()()()");
        }
        
        if(oldvalue.getStaff()==null){
            oldvalue.setStaff(new StaffBean());
            if(newvalue.getStaff().getStaff_no()!=null){
                if(!newvalue.getStaff().getStaff_no().equals(oldvalue.getStaff().getStaff_no())){
                    if(!(newvalue.getStaff().getStaff_no().equals("")&&oldvalue.getStaff().getStaff_no()==null)){
                        logger.log(person_making_id,project,reason,"staff_no",oldvalue.getStaff().getStaff_no(),newvalue.getStaff().getStaff_no());
                        changed = true;
                    }
                }
            }
            
        }
        
        
//       if(newvalue.getPerson_roles().size()>=oldvalue.getPerson_roles().size()){
//            for(int i=0;i<newvalue.getPerson_roles().size();i++){
//                if(newvalue.getPerson_rolesIndexed(i).getRole()!=oldvalue.getPerson_rolesIndexed(i).getRole()){
//                    logger.log(person_making_id,project,reason,"role",String.valueOf(oldvalue.getPerson_rolesIndexed(i).getRole()),String.valueOf(newvalue.getPerson_rolesIndexed(i).getRole()));
//                    changed = true;
//                }
//            }
//        }else{
//            for(int i=0;i<oldvalue.getPerson_roles().size();i++){
//                logger.log(person_making_id,project,reason,"role",String.valueOf(oldvalue.getPerson_rolesIndexed(i).getRole()),String.valueOf(newvalue.getPerson_rolesIndexed(i).getRole()));
//                changed = true;
//            }
//        }
        
        
        return changed;
        /*
         *(int user, int project, String reason, String item, String oldVal, String newVal)
         
         
logger.log(form.getPerson_id(),-1,"" ,"Registration","",form.getUser_name());
         */
    }
}
