<%@ taglib uri="http://struts.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-bean" prefix="bean" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-html" prefix="html" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-logic" prefix="logic" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-nested" prefix="nested" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<tiles:insert page="../tiles/layout.jsp" flush="true">

    <tiles:put name="title" type="string">

        <bean:message key="usermanagment.titles.changedetail"/>
            
    </tiles:put>

    <tiles:put name="body" type="string">   
        
        <html:messages id="error" message="false">
            <p><bean:write name="error"/></p>
        </html:messages>
        
        <html:form action="/management/updateDetail.do" method="post">

            <P>Person ID: <html:text property="person.person_id" readonly="true" value="${detail.person.person_id}"/><html:errors property="person.person_id"/>
            <P>Login name: <html:text property="person.user_name" maxlength="16" value="${detail.person.user_name}" readonly="true"/><html:errors property="person.user_name"/>
            
            <P>First name (given name): <html:text property="person.first_name" maxlength="64" value="${detail.person.first_name}"/><html:errors property="person.first_name"/>
            <P>Last name (family name): <html:text property="person.surname" maxlength="64" value="${detail.person.surname}"/><html:errors property="person.surname"/>
 

            <% if (request.isUserInRole("1")){ %>           
            <P>INACTIVE: 
            <%--input type="checkbox" name="person.inactive" <c:if test="${detail.person.inactive==true}"> checked="checked"</c:if>--%>
            <html:checkbox name="detail" property="person.inactive"/><html:errors property="person.inactive"/>
            <%--html:hidden property="person.pwd" value="${detail.person.pwd}"/--%>

            <P>ROLE:</P>
            <c:set var="found" value="0"/>
            <logic:iterate id="r" name="allroles" indexId="i">
                <logic:iterate id="pr" name="detail" property="person_roles" indexId="j">
                    <c:if test="${detail.person_roles[j].role==r.role_id}">
                        <%--html:multibox name="detail" property="person_rolesIndexed[${i}].role" value="${r.role_id}"/--%>
                        <input type="checkbox" name="person_rolesIndexed[${i}].role" value="${r.role_id}" checked="checked">:${r.role_description}<br>
                        <c:set var="found" value="1"/>
                    </c:if>
                </logic:iterate>
                <c:if test="${found == 0}">
                    <html:multibox property="person_rolesIndexed[${i}].role" value="${r.role_id}"/>
                    <%--input type="checkbox" name="person_rolesIndexed[${i}].role" value="${r.role_id}"--%>:${r.role_description}<br>
                </c:if>
                <c:set var="found" value="0"/>
            </logic:iterate>
            <%} %>

            <P>HEMIS number: <html:text property="student.hemis_no" value="${detail.student.hemis_no}"/><html:errors property="student.hemis_no"/>
            <P>Final Year: <html:text property="student.final_year" value="${detail.student.final_year}"/><html:errors property="student.final_year"/>

            <P>Course: 
            <html:select property="student.degree_stream" value="${detail.student.degree_stream}">
                <html:option value="NA">NOT AVAILABLE</html:option>
                <html:options collection="degreeStreams" property="value" labelProperty="label"/>
            </html:select><html:errors property="student.degree_stream"/></P>

            <c:forEach var="i" begin="0" end="1">

                <P>E-mail ${i+1}: 
                <c:if test="${fn:length(detail.person_emails)>=i+1}">
                    <html:text name="detail" property="person_emails[${i}].e_mail_add" value="${detail.person_emails[i].e_mail_add}"/>
                    <% if (request.isUserInRole("1")){ %>                  
                    SUSPENDED: 
                    <%--input type="checkbox" name="person_emailsIndexed[${i}].e_mail_suspended" <c:if test="${detail.person_emails[i].e_mail_suspended==true}">checked="checked"</c:if>--%>
                    <html:checkbox name="detail" property="person_emailsIndexed[${i}].e_mail_suspended" /> <%--value="${detail.person_emails[i].e_mail_suspended}"--%>
                    <%} %>
                </c:if>
                <c:if test="${fn:length(detail.person_emails)<i+1}">
                    <html:text name="detail" property="person_emails[${i}].e_mail_add" value=""/>
                    <%--ACTIVE: <input type="checkbox" name="person_emails[${i}].e_mail_suspended"><html:checkbox property="person_emails[${i}].e_mail_suspended"/>--%>
                </c:if>

            </c:forEach>
            
            <c:forEach var="i" begin="0" end="1">
                <P>Telephone Number ${i+1}: 
                <html:text name="detail"property="tel_numbers[${i}].tel_number" value="${detail.tel_numbers[i].tel_number}"/>
            </c:forEach>



            <P>Change Password: 
        
            <P>Old Password: <html:password property="oldpassword" redisplay="false" maxlength="16"/><html:errors property="oldpassword"/>
            <P>New password: <html:password property="password1" redisplay="false" maxlength="16"/><html:errors property="password1"/>
            <P>Confirm password: <html:password property="password2" redisplay="false" maxlength="16"/><html:errors property="password2"/><html:errors property="password2"/>


        
            <% if (request.isUserInRole("1")){ %>
            <P>STAFF Number: <html:text property="staff.staff_no" value="${detail.staff.staff_no}"/><html:errors property="staff.staff_no"/></P>
            <%} %>


            <P>REASON:<html:text property="reason"/><html:errors property="reason"/></P>

            <br><html:submit/><html:reset/><html:cancel/>
        </html:form>
        
    </tiles:put>

</tiles:insert>