<%@ taglib uri="http://struts.apache.org/tags-tiles" prefix="tiles" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-bean" prefix="bean" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-html" prefix="html" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-logic" prefix="logic" %>
<%@ taglib uri="http://jakarta.apache.org/struts/tags-nested" prefix="nested" %>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/functions" prefix="fn"%>

<script LANGUAGE="JavaScript">
    <!--
    // Nannette Thacker http://www.shiningstar.net
    function confirmSubmit()
    {
    var agree=confirm("Are you sure you wish to continue?");
    if (agree)
    return true ;
    else
    return false ;
    }
    // -->
</script>


<tiles:insert page="../tiles/layout.jsp" flush="true">

    <tiles:put name="title" type="string">

        <bean:message key="usermanagment.titles.home"/>
            
    </tiles:put>
   
    <tiles:put name="body" type="string">   
        <c:choose>
            <c:when test="${ param.state == 'updated' }">
                <center><h2><bean:message key="usermanagment.states.updated"/></h2></center>
            </c:when>
        
            <c:when test="${ param.state == 'noupdate' }">
                <center><h2><bean:message key="usermanagment.states.noupdate"/></h2></center>
            </c:when>

            <c:when test="${ param.state == 'deleted' }">
                <center><h2><bean:message key="usermanagment.states.deleted"/></h2></center>
            </c:when>
        </c:choose>   
        <table width="100%" border="0" cellpadding="5" cellspacing="2">  
    
            <tr>
                <th valign="top" class="tableHead">Person ID</th>
                <th valign="top" class="tableHead">User Name</th>
                <th valign="top" class="tableHead">First Name</th>
                <th valign="top" class="tableHead">Surname</th>
                <th valign="top" class="tableHead">In-Active</th>
                <th valign="top" class="tableHead">DELETE</th>
                <th valign="top" class="tableHead">EDIT</th>

            </tr>

            <c:forEach items="${allocations}" var="person" begin="${(currentpage-1)*numberperpage}" end="${currentpage*numberperpage-1}">   
                <tr> 
                    <td valign="top" class="table">${person.person.person_id}</td>
                    <td valign="top" class="table">${person.person.user_name}</td>
                    <td valign="top" class="table">${person.person.first_name}</td>
                    <td valign="top" class="table">${person.person.surname}</td>
                    <td valign="top" class="table">${person.person.inactive}</td>
                    <td valign="top" class="table"><html:link href="../../management/userManagement.do?ACTION=DEL&ID=${person.person.person_id}" onclick="return confirmSubmit()">DELETE</html:link></td>
                    <td valign="top" class="table"><html:link href="../../management/userManagement.do?ACTION=EDIT&ID=${person.person.person_id}">EDIT</html:link></td>
                </tr>
           
            </c:forEach>     

        </table>
        Pages: <c:forEach items="${pages}" var="pages">
            <c:if test="${pages==currentpage}">${pages}</c:if>
            <c:if test="${pages!=currentpage}"><a href="../../management/userManagement.do?PAGE=${pages}${url}">${pages}</a></c:if>
            &nbsp;
        </c:forEach>
        <p>
            Total Users: ${fn:length(allocations)}
        </p>

        <html:form action="/management/userManagement" method="post">
            <table><b>SEARCH:</b>
                <tr>
                    <td>HEMIS</td><td><html:text property="hemis" maxlength="10"/></td>
                    <td>E-mail</td><td><html:text property="email" maxlength="64"/></td>
                </tr>
                <tr>
                    <td>USERNAME</td><td><html:text property="user_name" maxlength="16"/></td>
                    <td>Telephone</td><td><html:text property="telephone" maxlength="64"/></td>
                </tr>
                <tr>
                    <td>First Name</td><td><html:text property="first_name" maxlength="64"/></td>
                    <td>Surname</td><td><html:text property="surname" maxlength="64"/></td>
                </tr>
                <tr>
                    <td>Final Year</td><td><html:text property="final_year" maxlength="20"/> (e.g 2005/2006)</td>
                    <td>Course</td><td><html:select property="degree_stream">
                        <html:option value="NA">--Select degree course(or No course)--</html:option>
                        <html:options collection="degreeStreams" property="value" labelProperty="label"/>
                    </html:select></td>
                </tr>
                <tr>
                    <td>ROLE</td><td>
                    <c:forEach items="${allroles}" var="r">
                        ${r.role_description}<html:multibox property="roles" value="${r.role_id}"/>
                    </c:forEach></td>
                </tr>
                <tr>
                    <td>
                        <html:submit property="ACTION" value="SEARCH"/><html:reset/>
                        <html:submit property="ACTION" value="ALL" alt="LIST ALL" />
                    </td>
                </tr>
            </table>
        </html:form>
        <p><html:link forward="userHome"><< back</html:link></p>
        
    </tiles:put>

</tiles:insert>
